import { Component as IntactComponent, VNodeComponentClass, IntactDom, Props, ComponentClass } from 'intact';
import { ComponentOptions, ComponentInternalInstance, HTMLAttributes } from 'vue';
import { normalizeChildren } from './normalize';
import { functionalWrapper } from './functionalWrapper';
export * from 'intact';
export { normalizeChildren as normalize };
export interface IntactComponentOptions extends ComponentOptions {
    Component: typeof Component;
}
declare type VNodeComponentClassMaybeWithVueInstance = VNodeComponentClass<ComponentClass> & {
    _vueInstance?: ComponentInternalInstance;
};
declare type IntactVueNextProps<P, E> = Readonly<P> & Readonly<Omit<HTMLAttributes, keyof P>> & Readonly<{
    [K in keyof P as `onChange:${string & K}`]?: (oldValue: P[K], newValue: P[K]) => void;
}> & Readonly<{
    [K in keyof E as `on${Capitalize<string & K>}`]?: (...args: any[] & E[K]) => void;
}>;
declare const mountedQueueStack: Map<number, Function[]>;
export { mountedQueueStack };
export declare class Component<P = {}, E = {}, B = {}> extends IntactComponent<P, E, B> {
    static $cid: string;
    static $doubleVNodes: boolean;
    static __cache: IntactComponentOptions | null;
    static get __vccOpts(): IntactComponentOptions;
    static functionalWrapper: typeof functionalWrapper;
    static normalize: typeof normalizeChildren;
    vueInstance: ComponentInternalInstance | undefined;
    private $isVueNext;
    $props: IntactVueNextProps<P, E>;
    constructor(props: Props<P, Component<P>> | null | undefined, $vNode: VNodeComponentClassMaybeWithVueInstance, $SVG: boolean, $mountedQueue: Function[], $parent: ComponentClass | null);
    $render(lastVNode: VNodeComponentClass<this> | null, nextVNode: VNodeComponentClass<this>, parentDom: Element, anchor: IntactDom | null, mountedQueue: Function[]): void;
    $update(lastVNode: VNodeComponentClass<this>, nextVNode: VNodeComponentClass<this>, parentDom: Element, anchor: IntactDom | null, mountedQueue: Function[], force: boolean): void;
}
